pliny.namespace({
  name: "Primrose",
  description: "Primrose helps you make VR applications for web browsers as easy as making other types of interactive web pages.\n\
\n\
This top-level namespace contains classes for manipulating and viewing 3D environments."
});

import Angle from "./Angle";
import Audio from "./Audio";
import BrowserEnvironment from "./BrowserEnvironment";
import Constants from "./constants";
import Controls from "./Controls";
import Displays from "./Displays";
import DOM from "./DOM";
import Graphics from "./Graphics";
import HTTP from "./HTTP";
import Input from "./Input";
import Keys from "./Keys";
import Network from "./Network";
import Pointer from "./Pointer";
import Random from "./Random";
import Replay from "./Replay";
import Text from "./Text";
import Tools from "./Tools";

export {
  Angle,
  Audio,
  BrowserEnvironment,
  Constants,
  Controls,
  Displays,
  DOM,
  Graphics,
  HTTP,
  Input,
  Keys,
  Network,
  Pointer,
  Random,
  Replay,
  Text,
  Tools
};

export default {
  Angle,
  Audio,
  BrowserEnvironment,
  Constants,
  Controls,
  Displays,
  DOM,
  Graphics,
  HTTP,
  Input,
  Keys,
  Network,
  Pointer,
  Random,
  Replay,
  Text,
  Tools
};
